﻿;;
;; Conversion des OD (Object data) de MAP (ou CIVIL) en XDATA AutoCAD
;; Nom de l'application XDATA enregistre = Nom de la table OD
;; Type = TEXT avec dedans "NomChamp=xxxxxx
;; Avec xxxxxx = Contenu du champ OD (Chaine, Reel/Flottant, Entier, etc)
;; Commande au clavier : OD2XD
;; Routine developpee par Olivier Eckmann - 20/11/2009
;;

(defun C:OD2XD ( / Elt LstTable EltLstTable Jeu I iNbJeu iEltLst iNbEltLst EltTable)
  ;récupère la liste des tables de données d'objet
  (setq LstTable (ade_odtablelist))
  ;boucle sur chaque objet
;;  (setq Jeu (ssget "x"))
  (setq Jeu (ssget))
  (setq I 0  iNbJeu (sslength JEU))
  (repeat iNbJeu
    (setq Elt (ssname Jeu I))
    (setq I (1+ I))
    ;récupère les tables de l'objet
    (if (setq EltLstTable (ade_odgettables Elt))
      (progn
      (setq iEltLst 0  iNbEltLst (length EltLstTable))
      (repeat iNbEltLst
	(setq EltTable (nth iEltLst EltLstTable))
	(setq iEltLst (1+ iEltLst))
	(setq oTableDef (ade_odtabledefn EltTable))
	;récupère le nom de la table
	(setq sNomTable (cdr (assoc "Tablename" oTableDef)))
	(regapp sNomTable)
	(setq exdata (list sNomTable))
	;récupère la liste des noms de champ
	(setq oLstChamp (cdr (assoc "Columns" oTableDef)))
	(setq iChamp 0 iNbChamp (length oLstChamp))
	(repeat iNbChamp
          (setq sNomChamp  (cdr (assoc "ColName" (nth iChamp oLstChamp))))
	  (setq sTypeChamp (cdr (assoc "ColType" (nth iChamp oLstChamp))))
	  (if (= sTypeChamp "Real")      (setq sValChamp (rtos (ade_odgetfield Elt EltTable sNomChamp 0) 2 6)))
	  (if (= sTypeChamp "Integer")   (setq sValChamp (itoa (ade_odgetfield Elt EltTable sNomChamp 0))))
	  (if (= sTypeChamp "Character") (setq sValChamp       (ade_odgetfield Elt EltTable sNomChamp 0)) )
	  (setq iChamp (1+ iChamp))
	  ;récupère la valeur du champ
	  (setq exdata (append exdata (list (cons 1000 (strcat sNomChamp "=" sValChamp)))))
	)
	(setq exdata (list (list -3 exdata)))
      )
      ;Ajoute les xdata
      (setq newent (append (entget Elt) exdata))
      ;Met à jour l'objet
      (entmod newent)
      )
    )
  )
)